import {ComponentFixture, TestBed} from '@angular/core/testing';

import {ClinicalExamsComponent} from './clinical-exams.component';
import {of} from 'rxjs';
import {ClinicalObservationsService} from './clinical-observations.service';
import {DataCardService} from '../../api/data-card.service';

describe('ClinicalExamsComponent', () => {
  let component: ClinicalExamsComponent;
  let fixture: ComponentFixture<ClinicalExamsComponent>;

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      declarations: [ ClinicalExamsComponent ],
      providers: [
        { provide: ClinicalObservationsService, useValue: {observationGroups: of({mother: {rows: []}, fetuses: []})}},
        { provide: DataCardService, useValue: {isDataCardClosed: of(false)}}
      ]
    })
    .compileComponents();
  });

  beforeEach(() => {
    fixture = TestBed.createComponent(ClinicalExamsComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });

  it('should have a method that can open the measurement modal', () => {
    component.measurementsModal = {isOpen: false} as any;
    expect(component.measurementsModal?.isOpen).toBeFalsy();
    component.createMeasurements();
    expect(component.measurementsModal?.isOpen).toBeTrue();
  });

  it('should have a method that can open the measurement modal for the related activity', () => {
    component.showRelatedActivityModal = {isOpen: false} as any;
    expect(component.showRelatedActivityModal?.isOpen).toBeFalsy();
    component.showActivity('1337');
    expect(component.showRelatedActivityModal?.isOpen).toBeTrue();
    expect(component.showRelatedActivityModal?.activityId).toBe('1337');
  });
});
